/* Include la definizione della strutura AudioFx ed i prototipi
   delle funzioni che utilizzeremo nel nostro effetto.             */
#include "audiofx.h"
#include <math.h>

static
void makedb (float value, char* text)
{
	if (value <= 0)
		strcpy(text, "-oo");
	else
		sprintf (text, "%2.2f", log10(value)*20);
}


/* Chiede l'etichetta del parametro nParam. L'etichetta dovr 
   essere scritta in szText */
void GetParameterLabel (struct AudioFx* fx, long nParameter, char* szText)
{
	if (nParameter == kWet)
		strcpy(szText, "dB");
	else
	if (nParameter == kDry)
		strcpy(szText, "dB");
	else
	if (nParameter == kRoomSize)
		strcpy(szText, "%");
	else
	if (nParameter == kFeedback)
		strcpy(szText, "%");
}


/* Valore testuale del parametro */
void GetParameterDisplay (struct AudioFx* fx, long nParameter, char* szText)
{
	Program* pg = fx->programs + fx->nCurProgram;

	if (nParameter == kWet)
		makedb(pg->wet, szText);
	else
	if (nParameter == kDry)
		makedb(pg->dry, szText);
	else
	if (nParameter == kRoomSize)
		sprintf (szText, "%3.1f", pg->room_size*100);
	else
	if (nParameter == kFeedback)
		sprintf (szText, "%3.1f", pg->feedback*100);
	
}

/* Nome testuale del parametro */
void GetParameterName (struct AudioFx* fx, long nParameter, char* szText)
{		
	struct Program_tag* pg = fx->programs + fx->nCurProgram;
	*szText = '\0';
	
	
	if (nParameter == kWet)
		strcpy(szText, "Wet");
	else
	if (nParameter == kDry)
		strcpy(szText, "Dry");
	else
	if (nParameter == kRoomSize)
		strcpy(szText, "Size");
	else
	if (nParameter == kFeedback)
		strcpy(szText, "Feedback");
}

/* Ritorna il valore del paramtetro */
float GetParameter (struct AudioFx* fx, long nParameter)
{
	Program* pg = fx->programs + fx->nCurProgram;
	
	if (nParameter == kWet)
		return pg->wet;
	else
	if (nParameter == kDry)
		return pg->dry;
	else
	if (nParameter == kRoomSize)
		return pg->room_size;
	else
	if (nParameter == kFeedback)
		return pg->feedback;
	else
		return 0;
}

/* Ritorna il nome del programma in szProgramName */
void GetProgramName (struct AudioFx* fx, char* szProgramName)
{
	strcpy (szProgramName, fx->programs[fx->nCurProgram].name);	
}
