#include "audiofx.h"

float Delay_tap_lpf (Delay* delay, float input);

void Process (struct AudioFx* fx, float** inputs, float** outputs, long sampleFrames)
{
	int k, d;
	float* InSinistro = inputs[0];
	float* InDestro = inputs[1];
	float* OutSinistro = outputs[0];
	float* OutDestro = outputs[1];
	float input, output;
	float bus_left, bus_right;
	
	for (k = 0; k < sampleFrames; ++k)
	{
		output = 0;		
		
		bus_left = Delay_tap_lpf(fx->dly_left, InSinistro[k]);
		bus_right = Delay_tap_lpf(fx->dly_right, InDestro[k]);

		bus_left += Delay_tap_lpf(fx->dly_left + 1, InSinistro[k]);
		bus_right += Delay_tap_lpf(fx->dly_right + 1, InDestro[k]);

		bus_left += Delay_tap_lpf(fx->dly_left + 2, InSinistro[k]);
		bus_right += Delay_tap_lpf(fx->dly_right + 2, InDestro[k]);

		bus_left += Delay_tap_lpf(fx->dly_left + 3, InSinistro[k]);
		bus_right += Delay_tap_lpf(fx->dly_right + 3, InDestro[k]);

		bus_left += Delay_tap_lpf(fx->dly_left + 4, InSinistro[k]);
		bus_right += Delay_tap_lpf(fx->dly_right + 4, InDestro[k]);

		bus_left += Delay_tap_lpf(fx->dly_left + 5, InSinistro[k]);
		bus_right += Delay_tap_lpf(fx->dly_right + 5, InDestro[k]);

		bus_left = Allpass_tap(fx->aps_left, bus_left);
		bus_left = Allpass_tap(fx->aps_left + 1, bus_left);
		bus_left = Allpass_tap(fx->aps_left + 2, bus_left);
		
		bus_right = Allpass_tap(fx->aps_right, bus_right);
		bus_right = Allpass_tap(fx->aps_right + 1, bus_right);
		bus_right = Allpass_tap(fx->aps_right + 2, bus_right);

		OutSinistro[k] += InSinistro[k] * fx->dry + bus_left * fx->wet;
		OutDestro[k] += InDestro[k] * fx->dry + bus_right * fx->wet;
	}
}

void ProcessReplacing (struct AudioFx* fx, float** inputs, float** outputs, long sampleFrames)
{
}


float Delay_tap_lpf (Delay* delay, float input)
{
	float output = *(delay->prw);
	delay->history = output = output * delay->coef + delay->history * (1.0F - delay->coef);
	*(delay->prw) = output * delay->feedback + input;	
	if (++delay->prw >= delay->pmax) delay->prw = delay->samples;
	return output * delay->level;
}

/* allpass */
float Allpass_tap (Delay* delay, float input)
{
	float output, w0, temp;
	
	w0 = delay->prw[0] * delay->feedback + input;
	output = delay->prw[0] - delay->feedback * w0;
	delay->prw[0] = w0;
	if (++delay->prw >= delay->pmax) delay->prw = delay->samples;
	return output * delay->level;	
}

